// *=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
// ** Copyright UCAR (c) 1992 - 2007
// ** University Corporation for Atmospheric Research (UCAR)
// ** National Center for Atmospheric Research (NCAR)
// ** Research Applications Lab (RAL)
// ** P.O.Box 3000, Boulder, Colorado, 80307-3000, USA
// *=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*



////////////////////////////////////////////////////////////////////////


#ifndef  __MET_ANALYSIS_VSDB_OFFSETS_H__
#define  __MET_ANALYSIS_VSDB_OFFSETS_H__


////////////////////////////////////////////////////////////////////////

//
// VSDB Header Column offsets
//
static const int version_offset          = 0;
static const int model_offset            = 1;
static const int fcst_lead_offset        = 2;

static const int fcst_valid_offset       = 3;
static const int obtype_offset           = 4;
static const int vx_mask_offset          = 5;

static const int line_type_offset        = 6;
static const int var_offset              = 7;
static const int level_offset            = 8;

//
// VSDB SL1L2 Line Type offsets
//
static const int sl1l2_total_offset      = 10;
static const int sl1l2_fbar_offset       = 11;
static const int sl1l2_obar_offset       = 12;
static const int sl1l2_fobar_offset      = 13;
static const int sl1l2_ffbar_offset      = 14;
static const int sl1l2_oobar_offset      = 15;

//
// VSDB SAL1L2 Line Type offsets
//
static const int sal1l2_total_offset     = 10;
static const int sal1l2_fabar_offset     = 11;
static const int sal1l2_oabar_offset     = 12;
static const int sal1l2_foabar_offset    = 13;
static const int sal1l2_ffabar_offset    = 14;
static const int sal1l2_ooabar_offset    = 15;

//
// VVDB VL1L2 Line Type offsets
//
static const int vl1l2_total_offset      = 10;
static const int vl1l2_ufbar_offset      = 11;
static const int vl1l2_vfbar_offset      = 12;
static const int vl1l2_uobar_offset      = 13;
static const int vl1l2_vobar_offset      = 14;
static const int vl1l2_uvfobar_offset    = 15;
static const int vl1l2_uvffbar_offset    = 16;
static const int vl1l2_uvoobar_offset    = 17;

//
// VVDB VAL1L2 Line Type offsets
//
static const int val1l2_total_offset     = 10;
static const int val1l2_ufabar_offset    = 11;
static const int val1l2_vfabar_offset    = 12;
static const int val1l2_uoabar_offset    = 13;
static const int val1l2_voabar_offset    = 14;
static const int val1l2_uvfoabar_offset  = 15;
static const int val1l2_uvffabar_offset  = 16;
static const int val1l2_uvooabar_offset  = 17;

//
// VSDB FHO Line Type offsets
//
static const int fho_total_offset        = 10;
static const int fho_f_rate_offset       = 11;
static const int fho_h_rate_offset       = 12;
static const int fho_o_rate_offset       = 13;

//
// VSDB CTC Line Type offsets
//
static const int ctc_total_offset        = 10;
static const int ctc_fy_oy_offset        = 11;
static const int ctc_fy_on_offset        = 12;
static const int ctc_fn_oy_offset        = 13;
static const int ctc_fn_on_offset        = 14;

//
// VSDB CTP Line Type offsets
//
static const int ctp_total_offset        = 10;
static const int ctp_fy_oy_tp_offset     = 11;
static const int ctp_fy_on_tp_offset     = 12;
static const int ctp_fn_oy_tp_offset     = 13;
static const int ctp_fn_on_tp_offset     = 14;
static const int ctp_fy_tp_offset        = 15;
static const int ctp_fn_tp_offset        = 16;
static const int ctp_oy_tp_offset        = 17;
static const int ctp_on_tp_offset        = 18;

//
// VSDB CFP Line Type offsets
//
static const int cfp_total_offset        = 10;
static const int cfp_fy_oy_fp_offset     = 11;
static const int cfp_fy_on_fp_offset     = 12;
static const int cfp_fn_oy_fp_offset     = 13;
static const int cfp_fn_on_fp_offset     = 14;
static const int cfp_fy_offset           = 15;
static const int cfp_fn_offset           = 16;

//
// VSDB COP Line Type offsets
//
static const int cop_total_offset        = 10;
static const int cop_fy_oy_op_offset     = 11;
static const int cop_fy_on_op_offset     = 12;
static const int cop_fn_oy_op_offset     = 13;
static const int cop_fn_on_op_offset     = 14;
static const int cop_oy_offset           = 15;
static const int cop_on_offset           = 16;

//
// VSDB CTS Line Type offsets
//
static const int cts_total_offset        = 10;
static const int cts_baser_offset        = 11;
static const int cts_baser_ncl_offset    = 12;
static const int cts_baser_ncu_offset    = 13;
static const int cts_baser_bcl_offset    = 14;
static const int cts_baser_bcu_offset    = 15;
static const int cts_fmean_offset        = 16;
static const int cts_fmean_ncl_offset    = 17;
static const int cts_fmean_ncu_offset    = 18;
static const int cts_fmean_bcl_offset    = 19;
static const int cts_fmean_bcu_offset    = 20;
static const int cts_acc_offset          = 21;
static const int cts_acc_ncl_offset      = 22;
static const int cts_acc_ncu_offset      = 23;
static const int cts_acc_bcl_offset      = 24;
static const int cts_acc_bcu_offset      = 25;
static const int cts_fbias_offset        = 26;
static const int cts_fbias_bcl_offset    = 27;
static const int cts_fbias_bcu_offset    = 28;
static const int cts_pody_offset         = 29;
static const int cts_pody_ncl_offset     = 30;
static const int cts_pody_ncu_offset     = 31;
static const int cts_pody_bcl_offset     = 32;
static const int cts_pody_bcu_offset     = 33;
static const int cts_podn_offset         = 34;
static const int cts_podn_ncl_offset     = 35;
static const int cts_podn_ncu_offset     = 36;
static const int cts_podn_bcl_offset     = 37;
static const int cts_podn_bcu_offset     = 38;
static const int cts_pofd_offset         = 39;
static const int cts_pofd_ncl_offset     = 40;
static const int cts_pofd_ncu_offset     = 41;
static const int cts_pofd_bcl_offset     = 42;
static const int cts_pofd_bcu_offset     = 43;
static const int cts_far_offset          = 44;
static const int cts_far_ncl_offset      = 45;
static const int cts_far_ncu_offset      = 46;
static const int cts_far_bcl_offset      = 47;
static const int cts_far_bcu_offset      = 48;
static const int cts_csi_offset          = 49;
static const int cts_csi_ncl_offset      = 50;
static const int cts_csi_ncu_offset      = 51;
static const int cts_csi_bcl_offset      = 52;
static const int cts_csi_bcu_offset      = 53;
static const int cts_gss_offset          = 54;
static const int cts_gss_bcl_offset      = 55;
static const int cts_gss_bcu_offset      = 56;
static const int cts_hk_offset           = 57;
static const int cts_hk_ncl_offset       = 58;
static const int cts_hk_ncu_offset       = 59;
static const int cts_hk_bcl_offset       = 60;
static const int cts_hk_bcu_offset       = 61;
static const int cts_hss_offset          = 62;
static const int cts_hss_bcl_offset      = 62;
static const int cts_hss_bcu_offset      = 64;
static const int cts_odds_offset         = 65;
static const int cts_odds_ncl_offset     = 66;
static const int cts_odds_ncu_offset     = 67;
static const int cts_odds_bcl_offset     = 68;
static const int cts_odds_bcu_offset     = 69;

//
// VSDB CNT Line Type offsets
//
static const int cnt_total_offset        = 10;
static const int cnt_fbar_offset         = 11;
static const int cnt_fbar_ncl_offset     = 12;
static const int cnt_fbar_ncu_offset     = 13;
static const int cnt_fbar_bcl_offset     = 14;
static const int cnt_fbar_bcu_offset     = 15;
static const int cnt_fstdev_offset       = 16;
static const int cnt_fstdev_ncl_offset   = 17;
static const int cnt_fstdev_ncu_offset   = 18;
static const int cnt_fstdev_bcl_offset   = 19;
static const int cnt_fstdev_bcu_offset   = 20;
static const int cnt_obar_offset         = 21;
static const int cnt_obar_ncl_offset     = 22;
static const int cnt_obar_ncu_offset     = 23;
static const int cnt_obar_bcl_offset     = 24;
static const int cnt_obar_bcu_offset     = 25;
static const int cnt_ostdev_offset       = 26;
static const int cnt_ostdev_ncl_offset   = 27;
static const int cnt_ostdev_ncu_offset   = 28;
static const int cnt_ostdev_bcl_offset   = 29;
static const int cnt_ostdev_bcu_offset   = 30;
static const int cnt_pr_corr_offset      = 31;
static const int cnt_pr_corr_ncl_offset  = 32;
static const int cnt_pr_corr_ncu_offset  = 33;
static const int cnt_pr_corr_bcl_offset  = 34;
static const int cnt_pr_corr_bcu_offset  = 35;
static const int cnt_sp_corr_offset      = 36;
static const int cnt_kt_corr_offset      = 37;
static const int cnt_ranks_offset        = 38;
static const int cnt_frank_ties_offset   = 39;
static const int cnt_orank_ties_offset   = 40;
static const int cnt_me_offset           = 41;
static const int cnt_me_ncl_offset       = 42;
static const int cnt_me_ncu_offset       = 43;
static const int cnt_me_bcl_offset       = 44;
static const int cnt_me_bcu_offset       = 45;
static const int cnt_estdev_offset       = 46;
static const int cnt_estdev_ncl_offset   = 47;
static const int cnt_estdev_ncu_offset   = 48;
static const int cnt_estdev_bcl_offset   = 49;
static const int cnt_estdev_bcu_offset   = 50;
static const int cnt_mbias_offset        = 51;
static const int cnt_mbias_bcl_offset    = 52;
static const int cnt_mbias_bcu_offset    = 53;
static const int cnt_mae_offset          = 54;
static const int cnt_mae_bcl_offset      = 55;
static const int cnt_mae_bcu_offset      = 56;
static const int cnt_mse_offset          = 57;
static const int cnt_mse_bcl_offset      = 58;
static const int cnt_mse_bcu_offset      = 59;
static const int cnt_bcmse_offset        = 60;
static const int cnt_bcmse_bcl_offset    = 61;
static const int cnt_bcmse_bcu_offset    = 62;
static const int cnt_rmse_offset         = 63;
static const int cnt_rmse_bcl_offset     = 64;
static const int cnt_rmse_bcu_offset     = 65;
static const int cnt_e10_offset          = 66;
static const int cnt_e10_bcl_offset      = 67;
static const int cnt_e10_bcu_offset      = 68;
static const int cnt_e25_offset          = 69;
static const int cnt_e25_bcl_offset      = 70;
static const int cnt_e25_bcu_offset      = 72;
static const int cnt_e50_offset          = 72;
static const int cnt_e50_bcl_offset      = 73;
static const int cnt_e50_bcu_offset      = 74;
static const int cnt_e75_offset          = 75;
static const int cnt_e75_bcl_offset      = 76;
static const int cnt_e75_bcu_offset      = 77;
static const int cnt_e90_offset          = 78;
static const int cnt_e90_bcl_offset      = 79;
static const int cnt_e90_bcu_offset      = 80;

//
// VSDB MPR Line Type offsets
//
static const int mpr_total_offset        = 10;
static const int mpr_index_offset        = 11;
static const int mpr_obs_lat_offset      = 12;
static const int mpr_obs_lon_offset      = 13;
static const int mpr_obs_lvl_offset      = 14;
static const int mpr_obs_elv_offset      = 15;
static const int mpr_fcst_offset         = 16;
static const int mpr_obs_offset          = 17;
static const int mpr_climo_offset        = 18;

//
// VSDB NBRCTC Line Type offsets
//
static const int nbrctc_total_offset     = 10;
static const int nbrctc_fy_oy_offset     = 11;
static const int nbrctc_fy_on_offset     = 12;
static const int nbrctc_fn_oy_offset     = 13;
static const int nbrctc_fn_on_offset     = 14;

//
// VSDB NBRCTS Line Type offsets
//
static const int nbrcts_total_offset     = 10;
static const int nbrcts_baser_offset     = 11;
static const int nbrcts_baser_ncl_offset = 12;
static const int nbrcts_baser_ncu_offset = 13;
static const int nbrcts_baser_bcl_offset = 14;
static const int nbrcts_baser_bcu_offset = 15;
static const int nbrcts_fmean_offset     = 16;
static const int nbrcts_fmean_ncl_offset = 17;
static const int nbrcts_fmean_ncu_offset = 18;
static const int nbrcts_fmean_bcl_offset = 19;
static const int nbrcts_fmean_bcu_offset = 20;
static const int nbrcts_acc_offset       = 21;
static const int nbrcts_acc_ncl_offset   = 22;
static const int nbrcts_acc_ncu_offset   = 23;
static const int nbrcts_acc_bcl_offset   = 24;
static const int nbrcts_acc_bcu_offset   = 25;
static const int nbrcts_fbias_offset     = 26;
static const int nbrcts_fbias_bcl_offset = 27;
static const int nbrcts_fbias_bcu_offset = 28;
static const int nbrcts_pody_offset      = 29;
static const int nbrcts_pody_ncl_offset  = 30;
static const int nbrcts_pody_ncu_offset  = 31;
static const int nbrcts_pody_bcl_offset  = 32;
static const int nbrcts_pody_bcu_offset  = 33;
static const int nbrcts_podn_offset      = 34;
static const int nbrcts_podn_ncl_offset  = 35;
static const int nbrcts_podn_ncu_offset  = 36;
static const int nbrcts_podn_bcl_offset  = 37;
static const int nbrcts_podn_bcu_offset  = 38;
static const int nbrcts_pofd_offset      = 39;
static const int nbrcts_pofd_ncl_offset  = 40;
static const int nbrcts_pofd_ncu_offset  = 41;
static const int nbrcts_pofd_bcl_offset  = 42;
static const int nbrcts_pofd_bcu_offset  = 43;
static const int nbrcts_far_offset       = 44;
static const int nbrcts_far_ncl_offset   = 45;
static const int nbrcts_far_ncu_offset   = 46;
static const int nbrcts_far_bcl_offset   = 47;
static const int nbrcts_far_bcu_offset   = 48;
static const int nbrcts_csi_offset       = 49;
static const int nbrcts_csi_ncl_offset   = 50;
static const int nbrcts_csi_ncu_offset   = 51;
static const int nbrcts_csi_bcl_offset   = 52;
static const int nbrcts_csi_bcu_offset   = 53;
static const int nbrcts_gss_offset       = 54;
static const int nbrcts_gss_bcl_offset   = 55;
static const int nbrcts_gss_bcu_offset   = 56;
static const int nbrcts_hk_offset        = 57;
static const int nbrcts_hk_ncl_offset    = 58;
static const int nbrcts_hk_ncu_offset    = 59;
static const int nbrcts_hk_bcl_offset    = 60;
static const int nbrcts_hk_bcu_offset    = 61;
static const int nbrcts_hss_offset       = 62;
static const int nbrcts_hss_bcl_offset   = 62;
static const int nbrcts_hss_bcu_offset   = 64;
static const int nbrcts_odds_offset      = 65;
static const int nbrcts_odds_ncl_offset  = 66;
static const int nbrcts_odds_ncu_offset  = 67;
static const int nbrcts_odds_bcl_offset  = 68;
static const int nbrcts_odds_bcu_offset  = 69;


//
// VSDB NBRCNT Line Type offsets
//
static const int nbrcnt_total_offset     = 10;
static const int nbrcnt_fbs_offset       = 11;
static const int nbrcnt_fbs_bcl_offset   = 12;
static const int nbrcnt_fbs_bcu_offset   = 13;
static const int nbrcnt_fss_offset       = 14;
static const int nbrcnt_fss_bcl_offset   = 15;
static const int nbrcnt_fss_bcu_offset   = 16;

//
// VSDB ISC Line Type offsets
//
static const int isc_total_offset        = 10;
static const int isc_nscale_offset       = 11;
static const int isc_mse_offset          = 12;
static const int isc_isc_offset          = 13;
static const int isc_fenergy2_offset     = 14;
static const int isc_oenergy2_offset     = 15;
static const int isc_baser_offset        = 16;
static const int isc_fbias_offset        = 17;

//
// The interp_mthd and interp_pnts columns vary by line type defined in
// vsdb_line.h:
//    vsdb_sl1l2,  vsdb_sal1l2, vsdb_vl1l2,  vsdb_val1l2
//    vsdb_fho,    vsdb_ctc,    vsdb_ctp,    vsdb_cfp,
//    vsdb_cop,    vsdb_cts,    vsdb_cnt,    vsdb_mpr,
//    vsdb_nbrctc, vsdb_nbrcts, vsdb_nbrcnt, vsdb_isc
//    no_vsdb_line_type
//
static const int interp_mthd_offset[] = {
   16, 16, 18, 18, 14, 15, 19, 17, 17, 70, 81, 19, -1, -1, -1, -1, -1
};

static const int interp_pnts_offset[] = {
   17, 17, 19, 19, 15, 16, 20, 18, 18, 45, 48, 20, 15, 44, 13, -1, -1
};

////////////////////////////////////////////////////////////////////////


#endif   /*  __MET_ANALYSIS_VSDB_OFFSETS_H__  */


////////////////////////////////////////////////////////////////////////
